/* Print out the averages and autocorrelations */

#include "comext.h"
#include <math.h>
#include <string.h>
#include <stdio.h>

char fileerror[128],filename[128];
char dataname[128],cdistname[128];

printdata(outname)
char outname[128];
{
FILE *fopen(), *fpax, *fpns;
int i,j,m,n;

    /* Open output file and print out cluster size histogram N[s] */
/*
    sprintf(cdistname, "ns/NS.%s", outname); fpns = fopen(cdistname,"w");
    fwrite(&sites,sizeof(int),1,fpns);
    fwrite(ns,sizeof(int),sites,fpns);
    fclose(fpns);
*/

    /* Open output file */
    sprintf(dataname, "BFC.%s", outname); fpax = fopen(dataname,"w");

  if (cntenergy) {
     
     numbins = cntenergy/binsz;
     for (m=0;m<M;m++) {
        avenergy[m] /= (double)cntenergy;
        avenersq[m] /= (double)cntenergy;
        avbinenersq[m] /= (double)numbins;
        spheat[m] = avbinenersq[m] - avenergy[m]*avenergy[m];
        errener[m] = sqrt( spheat[m] / (double)numbins );
        avspheat[m] /= (double)numbins;
        avspheatsq[m] /= (double)numbins;
        spheat[m] = avspheatsq[m] - avspheat[m]*avspheat[m];
        errspheat[m] = sqrt( spheat[m] / (double)numbins );
        spheat[m] = avenersq[m] - avenergy[m]*avenergy[m];

        if (cntenergy >= NA)  	 /* finish energy autocorr */
           /* finish_autocorr(lastNEA,EA,EA2,errEA,avenergy,cntenergy,m); */
           finish_autocorr(lastNEA,EA,avenergy,cntenergy,m);
     }

  }

  if (cntspin) {

     numbins = cntspin/binsz;
     for (m=0;m<M;m++) {
        avspin[m] /= (double)cntspin;
        avspinsq[m] /= (double)cntspin;
        avbinspinsq[m] /= (double)numbins;
        suss[m] = avbinspinsq[m] - avspin[m]*avspin[m];
        errspin[m] = sqrt( suss[m] / (double)numbins );
        avsuss[m] /= (double)numbins;
        avsusssq[m] /= (double)numbins;
        suss[m] = avsusssq[m] - avsuss[m]*avsuss[m];
        errsuss[m] = sqrt( suss[m] / (double)numbins );
        suss[m] = avspinsq[m] - avspin[m]*avspin[m];

        if (cntspin >= NA)    /* finish spin autocorr */
          /* finish_autocorr(lastNMA,MA,MA2,errMA,avspin,cntspin,m); */
          finish_autocorr(lastNMA,MA,avspin,cntspin,m);
     }

     n = 0;
     avmagsq[n] /= (double)cntspin;
     avbinmagsqsq[n] /= (double)numbins;
     errmagsq[n] = sqrt( (avbinmagsqsq[n] - avmagsq[n]*avmagsq[n]) / 
			 (double)numbins );
     for (m=0;m<M;m++) {
        avimsuss[m] /= (double)numbins;
        avimsusssq[m] /= (double)numbins;
        imsuss[m] = avimsusssq[m] - avimsuss[m]*avimsuss[m];
        errimsuss[m] = sqrt( imsuss[m] / (double)numbins );
        imsuss[m] = avmagsq[n] - avspin[m]*avspin[m];
     }

     if (cntspin >= NA)    /* finish spinsq autocorr */
        /* finish_autocorr(lastNM2A,M2A,M2A2,errM2A,avmagsq,cntspin,n); */
        finish_autocorr(lastNM2A,M2A,avmagsq,cntspin,n);
  }


/* Print out results */

fprintf(fpax,"Beta = %f  totswps = %d\n",beta,totswps);
fprintf(fpax,"Sites = %d x %d = %d\n", globisiz,globjsiz,globsites);
fprintf(fpax,"Sweeps per measurement = %d\n", sweeps);
fprintf(fpax,"\n");

/* Energy and specific heat */
for (m=0;m<M;m++)
fprintf(fpax,"E (%d) = %f +/- %f\n", cntenergy,avenergy[m],errener[m]);
for (m=0;m<M;m++)
fprintf(fpax,"Sp heat (%d) = %f  :  %f +/- %f\n", 
	cntenergy/binsz,globsites*spheat[m],globsites*avspheat[m],globsites*errspheat[m]);
fprintf(fpax,"\n");

/* Magnetization and susceptibility */
for (m=0;m<M;m++)
fprintf(fpax,"Mag (%d) = %f +/- %f\n", cntspin,avspin[m],errspin[m]);
for (m=0;m<M;m++)
fprintf(fpax,"Susp (%d) = %f  :  %f +/- %f\n", 
	cntspin/binsz,globsites*suss[m],globsites*avsuss[m],globsites*errsuss[m]);
fprintf(fpax,"\n");

/* Magnetization and susceptibility from Magsq*/
n = 0;
fprintf(fpax,"Magsq (%d) = %f +/- %f\n", cntspin,avmagsq[n],errmagsq[n]);
for (m=0;m<M;m++)
fprintf(fpax,"Susp (%d) = %f  :  %f +/- %f\n", 
	cntspin/binsz,globsites*imsuss[m],globsites*avimsuss[m],globsites*errimsuss[m]);
fprintf(fpax,"\n");

/* Maxima and minima of energies and spins */
for (m=0;m<M;m++) {
fprintf(fpax,"Emin =%10.6f   Emax =%10.6f\n", minenergy[m],maxenergy[m]);
fprintf(fpax,"Mmin =%10.6f   Mmax =%10.6f\n", minspin[m],maxspin[m]);
}
fprintf(fpax,"\n");

/* Autocorrelations in the energy and magnetization */
if (cntenergy >= NA) {
  fprintf(fpax,"Auto correlations\n");
  fprintf(fpax,"\n");
/*
  fprintf(fpax,"        Energy                  Magnetization\n");
  fprintf(fpax,"\n");
  for (i=0;i<NA;i++)
     fprintf(fpax,"%3d  %10.6f +/- %f  %10.6f +/- %f\n", 
	     i, EA[i]/EA[0], errEA[i]/EA[0], MA[i]/MA[0], errMA[i]/MA[0]);
  fprintf(fpax,"\n");
*/
  fprintf(fpax,"       Energy                  Magnetization\n");
  fprintf(fpax,"\n");
  for (m=0;m<M;m++) {
     if (EA[m][0] == 0.0) EA[m][0] = 1.0;
     if (MA[m][0] == 0.0) MA[m][0] = 1.0;
     if (M2A[m][0] == 0.0) M2A[m][0] = 1.0;
  }
  for (i=0;i<NA;i++) {
     fprintf(fpax,"%3d  ", i); 
     for (m=0;m<M;m++)
        fprintf(fpax,"%10.6f  ", EA[m][i]/EA[m][0]);
     for (m=0;m<M;m++)
        fprintf(fpax,"%10.6f  ", MA[m][i]/MA[m][0]);
     fprintf(fpax,"\n");
  }
  fprintf(fpax,"\n");
  fflush(fpax);

/* Autocorrelation length for the energy and magnetization */
  fprintf(fpax,"Auto correlation length\n");
  fprintf(fpax,"\n");
  for (i=1;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     for (m=0;m<M;m++) {
	if (EA[m][i] == 0.0) mass = 0.0;
        else mass = EA[m][i-1]/EA[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     for (m=0;m<M;m++) {
	if (MA[m][i] == 0.0) mass = 0.0;
        else mass = MA[m][i-1]/MA[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     fprintf(fpax,"\n");
  }
  fflush(fpax);
}

/* Autocorrelations in the magnetization squared */
if (cntspin >= NA) {
  fprintf(fpax,"\n");
  fprintf(fpax,"Auto correlations\n");
  fprintf(fpax,"\n");
  fprintf(fpax,"       Magsq\n");
  fprintf(fpax,"\n");
  for (i=0;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     n = 1;
     for (m=0;m<n;m++)
        fprintf(fpax,"%10.6f  ", M2A[m][i]/M2A[m][0]);
     fprintf(fpax,"\n");
  }
  fprintf(fpax,"\n");
  fflush(fpax);

/* Autocorrelation length for the magnetization squared */
  fprintf(fpax,"Auto correlation length\n");
  fprintf(fpax,"\n");
  for (i=1;i<NA;i++) {
     fprintf(fpax,"%3d  ", i);
     for (m=0;m<n;m++) {
	if (M2A[m][i] == 0.0) mass = 0.0;
        else mass = M2A[m][i-1]/M2A[m][i];
        if (mass > 0) mass = 1./log(mass);
        else          mass = 0.;
        fprintf(fpax,"%10.6f  ", mass);
     }
     fprintf(fpax,"\n");
  }
}
  fflush(fpax);

  /* close output file */
  fclose(fpax);

  return 0;

} /* end of printdata */



/* FUNCTIONS */

finish_autocorr(lastNA,A,average,count,m)
double lastNA[M][MAXNA], A[M][MAXNA];
double average[M];
int count, m;
{
   int i,j;

   for (j=0;j<NA;j++) {
      for (i=1;i<NA;i++)
	 lastNA[m][i-1] = lastNA[m][i];
      lastNA[m][NA-1] = 0;
      for (i=0;i<NA;i++)
	 A[m][i] += lastNA[m][0] * lastNA[m][i];
   }
   for (i=0;i<NA;i++) {
   /* Miss out NA-1 values at the start, and get an extra NA-(i+1)
      at the end, so need to subtract i from count to scale them */
      A[m][i] /= (count-i);
      A[m][i] -= (average[m] * average[m]);
   }
}

/*
finish_autocorr(lastNA,A,A2,errA,average,count,m)
double lastNA[M][MAXNA],A[M][MAXNA],A2[M][MAXNA],errA[M][MAXNA];
double average[M];
int count, m;
{
   int i,j;

   for (j=0;j<NA;j++) {
      for (i=1;i<NA;i++) lastNA[m][i-1] = lastNA[m][i];
      lastNA[m][NA-1] = 0;
      for (i=0;i<NA;i++) {
         autocorr = lastNA[m][0] * lastNA[m][i];
         A[m][i] += autocorr;
         A2[m][i] += autocorr * autocorr;
      }
   }
   for (i=0;i<NA;i++) {
      A[m][i] /= (count-i);
      A2[m][i] /= (count-i);
      errA[m][i] = A2[m][i] - (A[m][i] * A[m][i]);
      if (errA[m][i] < 0) errA[m][i] = 0;
      else errA[m][i] = sqrt( errA[m][i] / (count-1) );
      A[m][i] -= (average[m] * average[m]);
   }
}
*/
